.\"	$OpenBSD: nanosleep.2,v 1.13 2013/04/20 23:47:58 tedu Exp $
.\"	$NetBSD: nanosleep.2,v 1.1 1997/04/17 18:12:02 jtc Exp $
.\"
.\" Copyright (c) 1986, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)sleep.3	8.1 (Berkeley) 6/4/93
.\"
.Dd $Mdocdate: April 20 2013 $
.Dt NANOSLEEP 2
.Os
.Sh NAME
.Nm nanosleep
.Nd high resolution sleep
.Sh SYNOPSIS
.Fd #include <time.h>
.Ft int
.Fn nanosleep "const struct timespec *timeout" "struct timespec *remainder"
.Sh DESCRIPTION
.Fn nanosleep
suspends execution of the calling process for the duration specified by
.Fa timeout .
An unmasked signal will cause it to terminate the sleep early,
regardless of the
.Dv SA_RESTART
value on the interrupting signal.
.Sh RETURN VALUES
If the
.Fn nanosleep
function returns because the requested duration has elapsed, the value
returned will be zero.
.Pp
If the
.Fn nanosleep
function returns due to the delivery of a signal, the value returned
will be \-1, and the global variable
.Va errno
will be set to indicate the interruption.
If
.Fa remainder
is non-null, the timespec structure it references is updated to contain the
unslept amount (the requested duration minus the duration actually slept).
.Sh ERRORS
If any of the following conditions occur, the
.Fn nanosleep
function shall return \-1 and set
.Va errno
to the corresponding value.
.Bl -tag -width Er
.It Bq Er EINTR
.Nm
was interrupted by the delivery of a signal.
.It Bq Er EINVAL
.Fa timeout
specified a nanosecond value less than zero or greater than 1000 million,
or a second value less than zero or greater than 100 million.
.It Bq Er EFAULT
Either
.Fa timeout
or
.Fa remainder
points to memory that is not a valid part of the process address space.
.El
.Sh SEE ALSO
.Xr sleep 1 ,
.Xr sleep 3
.Sh STANDARDS
The
.Fn nanosleep
function conforms to
.St -p1003.1-2008 .
